#pragma opieMatrix(a,aStride,mult)
#pragma opieMatrix(b,bStride,mult)
#pragma opieMatrix(c,cStride,mult)

#pragma simpleIndex(i,mult)
#pragma simpleIndex(j,mult)
#pragma simpleIndex(k,mult)

void mult(double *a, double *b, double *c, int m, int n, int p, int aStride, int bStride, int cStride);



void mult(double *a, double *b, double *c, int m, int n, int p, int aStride, int bStride, int cStride) {
  register int i=0;
  register int j;
  register int k;

	for(i=0; i<aStride; i++)
	       	for(j=0; j<aStride; j++)
			a[i*aStride+j] = (double)(j+i+3);
	
	for(i=0; i<bStride; i++)
	       	for(j=0; j<bStride; j++)
		{
			if(i==j)
			{	b[i*bStride+j] = 2;}
			else
			{	b[i*bStride+j] = 0;}
		}


	                             /* ROW-MAJOR conventions   */
  for    (i = 0; i < aStride; i++)      /* select a row of c and a */
    for  (j = 0; j < bStride; j++)         /* select a col of c and b */
      for(k = 0; k < cStride; k++)         /* select a row of b and a col of a */
        c[i*cStride+ j] += a[i*aStride +k] * b[k*bStride +j];


}

